<template>
  <a-card :bordered="false">
    <a-form
      ref="formRef"
      :model="form"
      :rules="rules"
      :label-col="styleResponsive ? { md: 3, sm: 5, xs: 24 } : { flex: '90px' }"
      :wrapper-col="styleResponsive ? { md: 9, sm: 19, xs: 24 } : { flex: '1' }"
    >
      <a-form-item label="KEY" name="chatKey">
        <a-input
          allow-clear
          placeholder="请输入KEY"
          v-model:value="form.chatKey"
        />
        <a-button
          type="primary"
          class="ele-btn-icon"
          style="margin-top: 10px"
          @click="save"
        >
          <span>保存</span>
        </a-button>
      </a-form-item>
    </a-form>
  </a-card>
</template>

<script lang="ts" setup>
  import { reactive, ref, watch } from 'vue';
  import { message } from 'ant-design-vue';
  import { Setting } from '@/api/system/setting/model';
  import { useThemeStore } from '@/store/modules/theme';
  import { storeToRefs } from 'pinia';
  import { FormInstance } from 'ant-design-vue/es/form';
  import useFormData from '@/utils/use-form-data';
  import { addSetting, updateSetting } from '@/api/system/setting';

  const props = defineProps<{
    value?: string;
    // 修改回显的数据
    data?: Setting | null;
  }>();

  // const emit = defineEmits<{
  //   (e: 'done', value): void;
  // }>();

  // 保存字段信息(设定好key和描述,content里的字段是随意加的会自动转为json保存到数据库)
  // const settingId = ref(null);
  // const settingKey = ref('');
  // 是否开启响应式布局
  const themeStore = useThemeStore();
  const { styleResponsive } = storeToRefs(themeStore);
  // 提交状态
  const loading = ref(false);
  // 是否是修改
  const isUpdate = ref(false);
  //
  const formRef = ref<FormInstance | null>(null);
  // 表单数据
  const { form, resetFields, assignFields } = useFormData<Setting>({
    chatKey: '',
    tenantId: localStorage.getItem('tenantId')
  });

  // 表单验证规则
  const rules = reactive({
    chatKey: [
      {
        required: true,
        message: '请输入KEY',
        type: 'string',
        trigger: 'blur'
      }
    ]
  });

  /* 保存编辑 */
  const save = () => {
    if (!formRef.value) {
      return;
    }
    formRef.value
      .validate()
      .then(() => {
        loading.value = true;
        const appForm = {
          ...form,
          content: JSON.stringify(form)
        };
        const saveOrUpdate = isUpdate.value ? updateSetting : addSetting;
        saveOrUpdate(appForm)
          .then(() => {
            message.success('保存成功');
          })
          .catch((e) => {
            message.error(e.message);
          });
      })
      .catch(() => {});
  };

  watch(
    () => props.data,
    (data) => {
      if (data?.settingId) {
        isUpdate.value = true;
        // 表单赋值
        if (data.content) {
          const jsonData = JSON.parse(data.content);
          assignFields(jsonData);
        }
        // 其他必要参数
        form.settingId = data.settingId;
        form.settingKey = data.settingKey;
      } else {
        // 新增
        isUpdate.value = false;
        resetFields();
        form.settingKey = props.value;
      }
    }
  );
</script>
